/* 
 *           DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *                    Version 2, December 2004
 *  
 * Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
 * 
 * Everyone is permitted to copy and distribute verbatim or modified
 * copies of this license document, and changing it is allowed as long
 * as the name is changed.
 *  
 *            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 *  
 *  0. You just DO WHAT THE FUCK YOU WANT TO.
 */
/* 
 * Nazo No Masquerade script extractor
 * author : MooZ
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdint.h>

const uint8_t hirka[] =
{
    0x81, 0x40, 0x81, 0x40, 0x81, 0x40, 0x81, 0x40, 0x81, 0x40, 0x81, 0x40, 0x82, 0xF0, 0x82, 0x9F,
    0x82, 0xA1, 0x82, 0xA3, 0x82, 0xA5, 0x82, 0xA7, 0x82, 0xE1, 0x82, 0xE3, 0x82, 0xE5, 0x82, 0xC1,
    0x81, 0x40, 0x82, 0xA0, 0x82, 0xA2, 0x82, 0xA4, 0x82, 0xA6, 0x82, 0xA8, 0x82, 0xA9, 0x82, 0xAB,
    0x82, 0xAD, 0x82, 0xAF, 0x82, 0xB1, 0x82, 0xB3, 0x82, 0xB5, 0x82, 0xB7, 0x82, 0xB9, 0x82, 0xBB,
    0x82, 0xBD, 0x82, 0xBF, 0x82, 0xC2, 0x82, 0xC4, 0x82, 0xC6, 0x82, 0xC8, 0x82, 0xC9, 0x82, 0xCA,
    0x82, 0xCB, 0x82, 0xCC, 0x82, 0xCD, 0x82, 0xD0, 0x82, 0xD3, 0x82, 0xD6, 0x82, 0xD9, 0x82, 0xDC,
    0x82, 0xDD, 0x82, 0xDE, 0x82, 0xDF, 0x82, 0xE0, 0x82, 0xE2, 0x82, 0xE4, 0x82, 0xE6, 0x82, 0xE7,
    0x82, 0xE8, 0x82, 0xE9, 0x82, 0xEA, 0x82, 0xEB, 0x82, 0xED, 0x82, 0xF1, 0x81, 0x40, 0x81, 0x40,
    0x81, 0x40, 0x81, 0x42, 0x81, 0x75, 0x81, 0x76, 0x81, 0x41, 0x81, 0x45, 0x83, 0x92, 0x83, 0x40,
    0x83, 0x42, 0x83, 0x44, 0x83, 0x46, 0x83, 0x48, 0x83, 0x83, 0x83, 0x85, 0x83, 0x87, 0x83, 0x62,
    0x81, 0x5b, 0x83, 0x41, 0x83, 0x43, 0x83, 0x45, 0x83, 0x47, 0x83, 0x49, 0x83, 0x4a, 0x83, 0x4c,
    0x83, 0x4e, 0x83, 0x50, 0x83, 0x52, 0x83, 0x54, 0x83, 0x56, 0x83, 0x58, 0x83, 0x5a, 0x83, 0x5c,
    0x83, 0x5e, 0x83, 0x60, 0x83, 0x63, 0x83, 0x65, 0x83, 0x67, 0x83, 0x69, 0x83, 0x6a, 0x83, 0x6b,
    0x83, 0x6c, 0x83, 0x6d, 0x83, 0x6e, 0x83, 0x71, 0x83, 0x74, 0x83, 0x77, 0x83, 0x7a, 0x83, 0x7d,
    0x83, 0x7e, 0x83, 0x80, 0x83, 0x81, 0x83, 0x82, 0x83, 0x84, 0x83, 0x86, 0x83, 0x88, 0x83, 0x89,
    0x83, 0x8a, 0x83, 0x8b, 0x83, 0x8c, 0x83, 0x8d, 0x83, 0x8f, 0x83, 0x93, 0x81, 0x4a, 0x81, 0x4b
};

int main(int argc, char **argv)
{
	FILE *input;
	FILE *output;

    uint8_t kanjiTbl[512];
    
    uint8_t byte, prev, str, i;
    
	int kanjis;

    uint8_t buffer[1024]; /* I hope it'll be big enough :) */
    int bufferTop = 0;
    
    /* These are the (supposed) offsets of the text blocs in rom file. */
	const off_t start = 0x4C200;
	const off_t end   = 0x5C72D;
    
    off_t offset;
    
    size_t nRead;
    
    off_t current = 0;
    
    /* Read kanjis table. */
    input = fopen("kanjis.txt", "rb");
    if(input == NULL)
    {
        fprintf(stderr, "Unable to open kanjis table file (kanjis.txt): %s\n", strerror(errno));
        return 1;
    }
    nRead = fread(kanjiTbl, 1, 512, input);
    fclose(input);
    
    if(nRead != 512)
    {
        fprintf(stderr, "kanjis.txt seems to be corrupted (expected 512 bytes, read %d)\n", nRead);
        return 1;
    }
    
    /* Check command line arguments. */
	if(argc != 2)
	{
		fprintf(stderr, "%s rom\n", argv[0]);
		return 1;
	}

    /* Open rom (input) and script file (output) */
	input = fopen(argv[1], "rb");
	if(input == NULL)
	{
		fprintf(stderr, "Unable to open %s : %s\n", argv[1], strerror(errno));
		return 1;
	}

	output = fopen("script.txt", "wb");
	if(output == NULL)
	{
		fprintf(stderr, "Unable to open script.txt : %s\n", strerror(errno));
		return 1;
	}

    /* Jump to string bloc section */
    fseek(input, start, SEEK_SET);
        
    str  = 0;
    kanjis = 0;
    
    prev = 0x00;
    
    bufferTop = 0;
    while(1)
    {
        current = ftell(input);
        if(current == end)
            break;
        
        fread(&byte, 1, 1, input);
        
        if(str)
        {
            /* We are processing strings. */
            if(byte == 0x00) /* We reached the end of current string. */
            {
                if(bufferTop)
                {
                    fwrite(buffer, 1, bufferTop, output);
                    bufferTop = 0;
                }
                fprintf(output, "\n</string>\n");
                str = 0;
            }
            else if(byte == 0xfb) /* Kanjis tag. */
            {
                kanjis ^= 1;
            }
            else
            {
                if(kanjis) /* We are processing kanjis. */
                {
                    offset = ((unsigned int)byte) * 2;
                    buffer[bufferTop  ] = kanjiTbl[offset  ];
                    buffer[bufferTop+1] = kanjiTbl[offset+1];
                    bufferTop += 2;
                }
                else
                {
                    /* We are processing roman/hiragana/katakana/numbers */
                    if(byte == 0xfc) /* end of line */
                    {
                        if(bufferTop)
                        {
                            fwrite(buffer, 1, bufferTop, output);
                            bufferTop = 0;
                        }
                        
                        fprintf(output, "<endl/>\n");
                    }
                    else if( (byte >= ' ') && (byte <= 'Z') )  /* punctuation and roman letters */
                    {
                        buffer[bufferTop] = byte;
                        ++bufferTop;
                    }
                    else if( (byte >= 0x60) && (byte <= 0xDF) ) /* hiragana and katakana */
                    {
                        if((byte == 0xDE) || (byte == 0xDF)) /* accent */
                        {
                            buffer[bufferTop-1] += 1;
                        }
                        else
                        {
                            offset = ((unsigned int)(byte - 0x60)) * 2;
                            
                            buffer[bufferTop  ] = hirka[offset  ];
                            buffer[bufferTop+1] = hirka[offset+1];
                            bufferTop += 2;
                        }
                    }
                    else /* Unknown characters or icons */
                    {
                        if(bufferTop)
                        {
                            fwrite(buffer, 1, bufferTop, output);
                            bufferTop = 0;
                        }
                        fprintf(output, "&#x%02x", byte);
                    }
                }
            }            
        }
        else
        {
            if((byte == 0xfe) || (byte == 0xff))
            {
                if((byte == 0xfe) && bufferTop) /* The last byte of the command stack is the bloc id. So we skip it. */
                {
                    --bufferTop;
                }
                if(bufferTop) /* Print command bytes if any. */
                {
                    fprintf(output, "<cmd>");
                    for(i=0; i<bufferTop; ++i)
                    {
                        fprintf(output, "%02x", buffer[i]);
                    }
                    fprintf(output, "</cmd>\n");
                    bufferTop = 0;
                }
                
                if(byte == 0xfe) /* New bloc. */
                {
                    if(current != start+1) fprintf(output, "</bloc>\n\n");
                    fprintf(output, "<bloc id=%x offset=%lx>\n", prev, current-1);
                }
                else if(byte == 0xff) /* New string. Well it's more a paragraph than a single string. */
                {
                    fprintf(output, "<string offset=%lx>\n", current);
                    kanjis = 0;
                    str    = 1;
                }
            }
            else /* Unknown byte. Maybe used for some commands. */
            {
                buffer[bufferTop] = byte;
                ++bufferTop;
            }
        }
        
        prev = byte;
    }
   
    /* Close any remaining bloc. */
    if(prev == 0x00)
        fprintf(output, "</bloc>\n");
    
    /* Clean up */
	fclose(output);
	fclose(input);

	return 0;
}
